<!-- =========================================================================================
    File Name: ResetPassword.vue
    Description: Reset Password Page
========================================================================================== -->

<template>
  <div class="h-screen flex w-full bg-img">
    <div class="vx-col sm:w-3/5 md:w-3/5 lg:w-3/4 xl:w-3/5 mx-auto self-center">
      <vx-card>
        <div slot="no-body" class="full-page-bg-color">
          <div class="vx-row">
            <!-- Image -->
            <div
              class="vx-col hidden sm:hidden md:hidden lg:block lg:w-1/2 mx-auto self-center"
            >
              <img
                src="@/assets/images/pages/reset-password.png"
                alt="login"
                class="mx-auto"
              />
            </div>

            <div
              class="vx-col sm:w-full md:w-full lg:w-1/2 mx-auto self-center d-theme-dark-bg"
            >
              <div class="p-8">
                <div class="vx-card__title mb-8">
                  <!-- Title -->
                  <h4 class="mb-4">Đặt lại mật khẩu</h4>
                  <!-- Subtitle -->
                  <p>Vui lòng nhập mật khẩu mới của bạn.</p>
                </div>

                <!-- New Password -->
                <vs-input
                  v-validate="'required|min:6|max:24'"
                  data-vv-validate-on="blur"
                  name="password"
                  type="password"
                  label-placeholder="Mật khẩu mới"
                  v-model="password"
                  ref="password"
                  class="w-full"
                />
                <span
                  class="text-danger text-sm"
                  v-show="errors.has('password')"
                  >{{ errors.first("password") }}</span
                >

                <!-- Confirmed New Password -->
                <vs-input
                  v-validate="'required|min:6|max:24|confirmed:password'"
                  data-vv-validate-on="blur"
                  name="confirm_password"
                  type="password"
                  label-placeholder=" Nhập lại mật khẩu mới"
                  v-model="confirm_password"
                  data-vv-as="password"
                  class="w-full mt-8"
                />
                <span
                  class="text-danger text-sm"
                  v-show="errors.has('confirm_password')"
                  >{{ errors.first("confirm_password") }}</span
                >

                <div
                  class="flex flex-wrap justify-between flex-col-reverse sm:flex-row mt-8"
                >
                  <!-- Login Button -->
                  <vs-button
                    type="border"
                    to="/pages/login"
                    class="w-full sm:w-auto mb-8 sm:mb-auto mt-3 sm:mt-auto"
                  >
                    <div class="inline-flex items-center">
                      <feather-icon
                        icon="ChevronsLeftIcon"
                        svgClasses="h-4 w-4 mr-1"
                      ></feather-icon
                      ><span>Đăng nhập</span>
                    </div>
                  </vs-button>

                  <!-- Reset Password Button -->
                  <vs-button
                    class="w-full sm:w-auto"
                    @click="resetPassword"
                    :disabled="!validateForm"
                    >Đặt lại</vs-button
                  >
                </div>
              </div>
            </div>
          </div>
        </div>
      </vx-card>
    </div>
  </div>
</template>

<script>
import AuthenService from "../../services/AuthenService";

import { Validator } from "vee-validate";

/* <CUSTOM ERROR MESSAGE> */
const dict = {
  custom: {
    password: {
      required: "Vui lòng nhập mật khẩu của bạn",
      min: "Mật khẩu phải có ít nhất 6 ký tự",
      max: "Mật khẩu không được lớn hơn 24 ký tự"
    },
    confirm_password: {
      required: "Vui lòng nhập lại mật khẩu của bạn",
      min: "Mật khẩu phải có ít nhất 6 ký tự",
      max: "Mật khẩu không được lớn hơn 24 ký tự",
      confirmed: "Xác nhận mật khẩu không khớp"
    }
  }
};
Validator.localize("vi", dict); // register custom messages
/* </CUSTOM ERROR MESSAGE> */

export default {
  data() {
    return {
      password: "",
      confirm_password: "",
      email: "",
      otpCode: ""
    };
  },

  created() {
    this.fetchData({
      email: this.$route.params.value.email,
      otpCode: this.$route.params.value.otpCode
    });
  },

  computed: {
    validateForm() {
      return (
        !this.errors.any() && this.password != "" && this.confirm_password != ""
      );
    }
  },

  methods: {
    fetchData({ email, otpCode }) {
      this.email = email;
      this.otpCode = otpCode;
    },

    async resetPassword() {
      this.$globalBusyOn();

      try {
        if (this.password !== this.confirm_password)
          throw { message: "Mật khẩu không khớp. Vui lòng thử lại." };

        var res = await AuthenService.resetPassword({
          email: this.email,
          otpCode: this.otpCode,
          newPassword: this.password
        });

        this.$success(res.message);

        this.$router.push("/pages/login").catch(() => {});
      } catch (error) {
        this.$error({ message: error.message });
      } finally {
        this.$globalBusyOff();
      }
    }
  }
};
</script>
